import 'dart:async';
import 'dart:convert';
import 'package:http/http.dart' as http;
import 'dart:io';
import '../global.dart';

/// Send: 發送一般的API
Future<http.Response> Send(String api,{String ?postdata, Map<String,String> ?header})  {
  var url = Uri.parse(api);
  return http.post(
      url,
      body: postdata,
      headers: header
  );
}

/// GWSend: 發送GW類型的API
/// 發送GW類型的API要加上GW使用的header資訊
Future<http.Response> GWSend(String apiName,{Map<String,dynamic> ?postdata}) async {
  if(postdata == null) postdata = {};
  postdata["app_id"] = Globals.app_id;
  postdata["device_id"] = Globals.device_id;
  postdata["device_uuid"] = Globals.device_uuid;

  return Send(
      "${Globals.GWUrl}/$apiName",
      postdata: jsonEncode(postdata).toString(),
      header: httpHeader()
  );
}

Map<String,String> httpHeader() {
  return {
    "Content-Type": "application/json",
    "sequence": base64Encode(DateTime.now().millisecondsSinceEpoch.toString()),
    "appInfo": "${Globals.appName}:${Globals.appVersion}:${Globals.app_id}",
    "devType": "${Platform.operatingSystem}:${Globals.osVersion}",
    "devID": Globals.device_id,
    "tokenID": base64Encode(Globals.app_key),
    "vid": "",
    "signature": ""
  };
}

String base64Encode(String encodeStr) {
  var bytes = utf8.encode(encodeStr);
  return base64.encode(bytes);
}